function [W, E]=nlms(W, d, X, mu)
%  +-----------------------------------------+
%  |       NLMS Algorithm   04/2004          |
%  |         Antonio L. L. Ramos             |
%  |       alopesramos@yahoo.com.br          |
%  +-----------------------------------------+
% The algorithms have been implemented in a simple way
% (if I can say so...) to make them easy to understand.
% That means that, after you have mastered them, there is a
% lot of simplifications that can be achieved.
% So, feel free to modify and/or adjust them to your own experiments.
%
% It should be clear that the files are meant to be used for educational
% purposes only. No warranty for comercial use is offered and neither the publisher nor
% the authors shall be liable for any loss of any type.
% 0<mu<=2;
% gamma = small constant;
%---------------------------------------------------------
E = d-W'*X;
W = W + mu/(1e-3 +X'*X)*conj(E)*X;
%---------------------End of NLMS.m-----------------------